package jesse.keeblarcraft.EventMgr;

import jesse.keeblarcraft.AttributeMgr.AttributeMgr;
import jesse.keeblarcraft.AttributeMgr.AttributeTree;
import jesse.keeblarcraft.ConfigMgr.ConfigManager;
import jesse.keeblarcraft.ConfigMgr.GeneralConfig;
import jesse.keeblarcraft.Utils.DirectionalVec;
import net.fabricmc.fabric.api.networking.v1.PacketSender;
import net.minecraft.server.MinecraftServer;
import net.minecraft.server.network.ServerPlayNetworkHandler;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.server.world.ServerWorld;
import net.minecraft.text.Text;

public class PlayerJoinListener {
    private static PlayerJoinListener static_inst;
    private ConfigManager config = new ConfigManager();

    public static PlayerJoinListener GetInstance() {
        if (static_inst == null) {
            static_inst = new PlayerJoinListener();
        }
        return static_inst;
    }

    public void HandleServerJoinEvent(ServerPlayNetworkHandler handler, PacketSender sender, MinecraftServer server) {
        var player = handler.player;

        // Handle skill tree map instance
        if (AttributeMgr.activeTrees.containsKey(player.getUuidAsString()) == false) {
            AttributeMgr.activeTrees.put(player.getUuidAsString(), new AttributeTree(player.getUuidAsString()));
        }

        // Handle first time joining events (world spawn teleport, MOTD, etc)
        System.out.println("Running first time login stuff");
        IsFirstTimeLogin(player, server);
    }

    private void IsFirstTimeLogin(ServerPlayerEntity player, MinecraftServer server) {
        // Send the MOTD + Spawn in global spawn
        player.sendMessage(Text.of(GeneralConfig.GetInstance().GetMOTD()));
        if (GeneralConfig.GetInstance().IsNewPlayer(player.getUuidAsString())) {
            DirectionalVec coords = GeneralConfig.GetInstance().GetSpawnCoords();
            if (coords != null) {
                System.out.println("Coords is not null");
                System.out.println("Coords world key: " + server.getWorld(coords.world).asString());
                player.teleport(server.getWorld(coords.world), (float)coords.x, (float)coords.y,
                (float)coords.z, (float)coords.yaw, (float)coords.pitch);
            } else {
                System.out.println("Coords is a null object");
                System.out.println("Coords were null. Not warping player");
            }
        } else {
            System.out.println("Not a new player! Not running anything");
        }
    }
}
